package flink.zanxiangnet.ad.monitoring.config;

import com.zaxxer.hikari.HikariConfig;
import com.zaxxer.hikari.HikariDataSource;
import lombok.extern.slf4j.Slf4j;
import org.apache.ibatis.datasource.DataSourceFactory;
import ru.yandex.clickhouse.BalancedClickhouseDataSource;
import ru.yandex.clickhouse.settings.ClickHouseProperties;

import javax.sql.DataSource;
import java.util.Properties;

/**
 * Clickhouse连接池
 */
@Slf4j
public class ClickhouseDataSourceFactory implements DataSourceFactory {

    public static final String PROP_URL = "url";
    public static final String PROP_USER = "user";
    public static final String PROP_PASSWORD = "password";

    private Properties props;

    @Override
    public void setProperties(Properties props) {
        this.props = props;
    }

    @Override
    public DataSource getDataSource() {
        ClickHouseProperties ckProps = new ClickHouseProperties();
        ckProps.setUser(props.getProperty(PROP_USER));
        ckProps.setPassword(props.getProperty(PROP_PASSWORD));
        DataSource dataSource = new BalancedClickhouseDataSource(props.getProperty(PROP_URL), ckProps);

        HikariConfig config = new HikariConfig();
        // 此处还可以配置连接池大小，连接超时之类的
        config.setDataSource(dataSource);
        return new HikariDataSource(config);
    }
}
